package Pooru::Site::Controller::Random;
use v5.40;
use Mojo::Base "Mojolicious::Controller";


sub media ($self)
{
	$self->render_later;

	my $endpoint = $self->api_v0_url->path("random/media");
	$self->ua->get_p($endpoint)->then(sub ($tx) {
		return $self->render(
			text => "Backend error.",
			status => 500,
		) if $tx->error;

		return $self->redirect_to("show_media",
		    media_id => $tx->res->json->{id});
	})->wait;
}

sub tag ($self)
{
	$self->render_later;

	my $endpoint = $self->api_v0_url->path("random/tag");
	$self->ua->get_p($endpoint)->then(sub ($tx) {
		return $self->render(
			text => "Backend error.",
			status => 500,
		) if $tx->error;

		my @tags = $tx->res->json->{tags}->@*;
		my $url = $self->url_for("list_media")
		    ->query(tags => $tags[int(rand(@tags))]->{display} . " ");
		return $self->redirect_to($url);
	})->wait;
}

1;
